"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = mapRecurse;

var _bluebird = require("bluebird");

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new _bluebird2.default(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return _bluebird2.default.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function mapRecurse(func) {

  return function () {
    var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(node) {
      var newNode;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return func(node);

            case 2:
              newNode = _context.sent;

              if (!newNode.children) {
                _context.next = 7;
                break;
              }

              _context.next = 6;
              return _bluebird2.default.all(newNode.children.map(walker));

            case 6:
              newNode.children = _context.sent;

            case 7:
              return _context.abrupt("return", newNode);

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function walker(_x) {
      return _ref.apply(this, arguments);
    }

    return walker;
  }();
}