"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (absRoot) {
  var _this = this;

  return (0, _mapRecurse2.default)(function () {
    var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(absPath) {
      var relPath, absParsed, relParsed, stat, self;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              relPath = void 0;

              if (!absPath) {
                absPath = absRoot;
                relPath = "";
              } else {
                relPath = _path2.default.relative(absRoot, absPath);
              }

              absParsed = _path2.default.parse(absPath);
              relParsed = _path2.default.parse(relPath);
              _context.next = 6;
              return fs.statAsync(absPath);

            case 6:
              stat = _context.sent;
              self = {
                pathStr: absPath,
                path: absParsed,
                isFile: stat.isFile(),
                isDirectory: stat.isDirectory(),
                data: (0, _mergeProps.mergeWithObj)({}, {
                  slug: relParsed.name,
                  path: relParsed.dir.split("/")
                }),
                inheritance: undefined
              };

              if (!self.isDirectory) {
                _context.next = 12;
                break;
              }

              _context.next = 11;
              return fs.readdirAsync(absPath).map(function (pathStr) {
                return _path2.default.join(absPath, pathStr);
              });

            case 11:
              self.children = _context.sent;

            case 12:
              return _context.abrupt("return", self);

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, _this);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }());
};

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _bluebird = require("bluebird");

var _bluebird2 = _interopRequireDefault(_bluebird);

var _mapRecurse = require("../mapRecurse");

var _mapRecurse2 = _interopRequireDefault(_mapRecurse);

var _mergeProps = require("../mergeProps");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new _bluebird2.default(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return _bluebird2.default.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

var fs = _bluebird2.default.promisifyAll(require("fs"));